<?php
/*******************************************************************************
 * Copyright (C) 2007 Easter-eggs
 * https://ldapsaisie.org
 *
 * Author: See AUTHORS file in top-level directory.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

/**
 * LDAP attribute type postaladdress
 * See RFC4519: Line returns are replaced with '$'.
 */
class LSattr_ldap_postaladdress extends LSattr_ldap {

  /**
   * Return the display value of the attribute after handling it acording to its LDAP type
   *
   * @param mixed $data The attribute value
   *
   * @return mixed The display value of the attribute
   */
  public function getDisplayValue($data) {
    $ret = array();
    foreach(ensureIsArray($data) as $val)
      $ret[] = str_replace("$", "\n", $val);
    return $ret;
  }

  /**
   * Return the update value of the attribute after handling it acording to its LDAP type
   *
   * @param mixed $data The attribute value
   *
   * @return mixed The processed attribute value
   */
  public function getUpdateData($data) {
    $ret = array();
    foreach(ensureIsArray($data) as $val)
      $ret[] = str_replace("\n", "$", $val);;
    return $ret;
  }

}
